#CREATE YIELD CURVE WITH MODIFIED HOCKETT-SHERBY
#David Koch, Christian Ilg, Pedro Roehl
#PYTHON 3.5

import sys
import csv
import math
import time

C = float('<<c>>')
N = float('<<n>>')
D = float('<<d>>')
B = float('<<b>>')

def getYieldCurve():
	yieldcurve_eps = []
	yieldcurve_sig = []
	SamplePoints = 300
	stepsize = 2.0 / (SamplePoints-1)
	for i in range(SamplePoints):
		val = i*stepsize
		yieldcurve_eps.append(val)
		yieldcurve_sig.append(D+B*(1-math.exp(-C*val**N)))
	return yieldcurve_eps, yieldcurve_sig

yieldcurve_eps, yieldcurve_sig = getYieldCurve()

ycfile = 'yield_curve.inc'
f_yc = open(ycfile, 'w')
f_yc.write('*KEYWORD\n')
f_yc.write('$ Created: ' + time.strftime("%d.%m.%Y %H:%M:%S") + '\n')
f_yc.write('*DEFINE_CURVE_TITLE\n')
f_yc.write('yield curve\n')
f_yc.write('$     LCID      SIDR       SFA       SFO      OFFA      OFFO    DATTYP\n')
f_yc.write('       500         0    1.0000    1.0000    0.0000    0.0000\n')
f_yc.write('%20.8e %19.8e\n' %(0.0,  D))
for i in range(len(yieldcurve_eps)):
	if yieldcurve_sig[i] > D:
		f_yc.write('%20.8e %19.8e\n' %(yieldcurve_eps[i],  yieldcurve_sig[i]))
f_yc.close()

print("N o r m a l")
